﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace ProductInventoryTracker.Models
{
    public class Product
    {
        private List<ProductSaleHistory> _history;

        public Product()
        {
            //blank
        }

        public Product(int productId, string productName, bool inStock, double unitsInStock, double unitPrice)
        {
            ProductId = productId;
            ProductName = productName;
            InStock = inStock;
            UnitsInStock = unitsInStock;
            UnitPrice = unitPrice;
        }

        public int ProductId { get; set; }
        public string ProductName { get; set; }
        public bool InStock { get; set; }
        public double UnitsInStock { get; set; }
        public double UnitPrice { get; set; }

        public List<ProductSaleHistory> History
        {
            get
            {
                if (_history == null)
                {
                    _history = new List<ProductSaleHistory>();
                }
                return _history;
            }
            set
            {
                if (_history != value)
                {
                    _history = value;
                }
            }
        }
    }

    public class ProductSaleHistory
    {
        public ProductSaleHistory()
        {
            //blank
        }

        public ProductSaleHistory(int productId, DateTime date, double value)
        {
            ProductId = productId;
            Date = date;
            Value = value;
        }

        public int ProductId { get; set; }
        public DateTime Date { get; set; }
        public double Value { get; set; }
    }
}
