﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ProductInventoryTracker.Models;
using System.Collections.Generic;

namespace ProductInventoryTracker.ViewModels 
{
    public class MainViewModel
    {
        private List<Product> _products;
        private Product _selectedProduct = new Product();

        public MainViewModel()
        {
            //blank
        }

        public List<Product> Products
        {
            get
            {
                if (_products == null)
                {
                    // generate some sample data
                    Random _random = new Random();
                    _products = new List<Product>();
                    for (int i = 0; i < 50; i++)
                    {
                        _products.Add(new Product(i, "Product " + i, true, _random.Next(1, 100), _random.Next(i, 100) + _random.NextDouble()));
                    }
                    foreach (Product p in _products)
                    {
                        for (int i = 0; i < 10; i++)
                        {
                            p.History.Add(new ProductSaleHistory(p.ProductId, DateTime.Now.AddDays(i), _random.Next(1, 20)));
                        }
                    }
                }
                return _products;
            }
        }

        public Product SelectedProduct
        {
            get 
            { 
                return _selectedProduct; 
            }
            set 
            { 
                _selectedProduct = value;
            }
        }

    }
}
